﻿
// Button2Dlg.cpp : 実装ファイル
//

#include "pch.h"
#include "framework.h"
#include "Button2.h"
#include "Button2Dlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CButton2Dlg ダイアログ

UINT InterruptThread(LPVOID pParam)
{
	LONG len;
	UCHAR buf;
	ButtonInt* pBI = (ButtonInt*)pParam;

	pBI->bRunning = TRUE;
	pBI->cancel = 0;

	while (!pBI->cancel) {
		len = 1;
		pBI->IntEndpt->XferData(&buf, len);
		if (len==1) ::PostMessage(pBI->hWnd, pBI->uIDMessage, 0, (LPARAM)buf);
		Sleep(10); // 他のスレッドに制御を渡します
	}
	::PostMessage(pBI->hWnd, pBI->uIDMessage, 1, 0);
	pBI->bRunning = FALSE;
	return 0;
}


CButton2Dlg::CButton2Dlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_BUTTON2_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CButton2Dlg::~CButton2Dlg()
{
	while (m_BI.bRunning) Sleep(10);
	if (USBDevice) {
		USBDevice->Close();
		delete USBDevice;
		USBDevice = NULL;
	}
}

void CButton2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CButton2Dlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RESET_BUTTON, &CButton2Dlg::OnBnClickedResetButton)
	ON_MESSAGE(UWM_BUTTONINT, OnButtonInt)
	ON_BN_CLICKED(IDCANCEL, &CButton2Dlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDOK, &CButton2Dlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CButton2Dlg メッセージ ハンドラー

BOOL CButton2Dlg::OnInitDialog()
{
	int i, n;

	CDialogEx::OnInitDialog();

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	m_BI.bRunning = FALSE;

	USBDevice = new CCyUSBDevice(m_hWnd);	// USB通信用のクラスを生成します
	if (!(n = USBDevice->DeviceCount())) {	// USBケーブルにUSB機器が接続されていることを確認します　
		AfxMessageBox(L"No CyUSB3.sys-drived device is found.");
		PostMessage(WM_CLOSE);
		return TRUE;
	}
	for (i = 0; i < n; i++) {		// 接続されたUSB機器がsimpleio.iicが書き込まれたEZ-USBであることを確認します
		USBDevice->Open(i);
		if (USBDevice->VendorID == 0x04B4 && USBDevice->ProductID == 0x1004) break;
		USBDevice->Close();
	}
	if (i == n) {
		AfxMessageBox(L"No EZ-USB FX2LP Example Device is found.");
		PostMessage(WM_CLOSE);
		return TRUE;
	}
	if (!(n = USBDevice->EndPointCount())) {	// EZ-USBが内包するEndPointの数を確認します
		AfxMessageBox(L"No EndPoint is found.");
		PostMessage(WM_CLOSE);
		return TRUE;
	}
	for (i = 0; i < n; i++) {		// EndPoint 02/86をそれぞれ出力用/入力用変数(OutEndpt/InEndpt)に割り当てます
		if (USBDevice->EndPoints[i]->Address == 0x02) OutEndpt = USBDevice->EndPoints[i];
		else {
			if (USBDevice->EndPoints[i]->Address == 0x86) m_BI.IntEndpt = USBDevice->EndPoints[i];
		}
	}
	m_BI.IntEndpt->TimeOut = 0;

	m_strDeviceName = USBDevice->FriendlyName;
	SetWindowText(m_strDeviceName);	// 接続されたUSB機器の名称をウィンドウタイトルバーに表示します

	m_BI.hWnd = m_hWnd;
	m_BI.uIDMessage = UWM_BUTTONINT;
	AfxBeginThread(InterruptThread, &m_BI);

	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CButton2Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CButton2Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CButton2Dlg::OnBnClickedResetButton()
{
	LONG len = 1;

	OutBuff = 0x00;
	if (!OutEndpt->XferData(&OutBuff, len)) {
		AfxMessageBox(L"USB Bulk Transfer Failed.");
		m_BI.cancel = 1;
		return;
	}

	GetDlgItem(IDC_RESULT_STATIC)->SetWindowText(_T(""));	//　結果表示のクリア
}

LRESULT CButton2Dlg::OnButtonInt(WPARAM wParam, LPARAM lParam)
{
	switch (wParam) {
	case 0:if (lParam) GetDlgItem(IDC_RESULT_STATIC)->SetWindowText(_T("ボタンBが押されました"));
			else GetDlgItem(IDC_RESULT_STATIC)->SetWindowText(_T("ボタンAが押されました"));
			break;
	case 1:PostMessage(WM_CLOSE);
			break;
	}
	return 0L;
}


void CButton2Dlg::OnBnClickedCancel()
{
	if (m_BI.bRunning) m_BI.cancel = 1;
	else CDialogEx::OnCancel();
}


void CButton2Dlg::OnBnClickedOk()
{
}
